#ifndef SISTEMA_H
#define SISTEMA

#include "g2f.h"
#include <map>
#include <list>

using namespace std;

class Sistema_ecuaciones {

public:
	Sistema_ecuaciones( const char* ); // default constructor
	~Sistema_ecuaciones(); // default destructor
	int getStiffness( int = 0 ); // default verbose mode off
	void print_global();
	void hojaCalculo();
	int rightSide();
	int dirichletPto();
	int dirichletLin();
	int paresHomologos();
	int kelvin();
	int aBinario();
	int mkdir( const char* );
	int enrutar( const char* );
private:
// funciones
//	void print_local( PetscScalar ** );
	int local_matrix( double,double,double,double,double,double,int );
	int regiones();
	int regNodos( int**, int, int);
// variables
	int N_N;
	int N_E;
	int N_ED;
	float frec; // frecuencia de la densidad de corriente
	double VACIO; // permeabilidad magnetica en el vacio
	double **pNode; // para los nodos del mallado; getStiffness() regiones() archivoGmshPot()
	const char *ruta;
	char *ptrMesh, *ptrTemporal, // to work with input files
	*ptrConducti, *ptrPermeabi, *ptrDensidadCorri, *ptrDirichlet, *ptrKelvin,
	*ptrExtra, *ptrOpEjecu, *ptrRutaArchivo;
// LTS
	map<unsigned,double> permeabilidad; // lo utiliza local_matrix()
	map<unsigned,double> conductividad; // lo utiliza local_matrix()
	list<int> listaRegNodos0; //para nodos homologos
	list<int> listaRegNodos1; //para nodos homologos
};	// fin de la clase Rigidez

#endif
